package cn.iocoder.yudao.module.llm.service.prompttemplatesapplicationsbackup;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.llm.controller.admin.prompttemplatesapplicationsbackup.vo.*;
import cn.iocoder.yudao.module.llm.dal.dataobject.prompttemplatesapplicationsbackup.PromptTemplatesApplicationsBackupDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.llm.dal.mysql.prompttemplatesapplicationsbackup.PromptTemplatesApplicationsBackupMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.llm.enums.ErrorCodeConstants.*;

/**
 * Prompt 模板 应用关系表 备份表，记录模板和应用之间的多对多关系 Service 实现类
 *
 * @author 华大大模型
 */
@Service
@Validated
public class PromptTemplatesApplicationsBackupServiceImpl implements PromptTemplatesApplicationsBackupService {

    @Resource
    private PromptTemplatesApplicationsBackupMapper promptTemplatesApplicationsBackupMapper;

    @Override
    public Long createPromptTemplatesApplicationsBackup(PromptTemplatesApplicationsBackupSaveReqVO createReqVO) {
        // 插入
        PromptTemplatesApplicationsBackupDO promptTemplatesApplicationsBackup = BeanUtils.toBean(createReqVO, PromptTemplatesApplicationsBackupDO.class);
        promptTemplatesApplicationsBackupMapper.insert(promptTemplatesApplicationsBackup);
        // 返回
        return promptTemplatesApplicationsBackup.getId();
    }

    @Override
    public void updatePromptTemplatesApplicationsBackup(PromptTemplatesApplicationsBackupSaveReqVO updateReqVO) {
        // 校验存在
        validatePromptTemplatesApplicationsBackupExists(updateReqVO.getId());
        // 更新
        PromptTemplatesApplicationsBackupDO updateObj = BeanUtils.toBean(updateReqVO, PromptTemplatesApplicationsBackupDO.class);
        promptTemplatesApplicationsBackupMapper.updateById(updateObj);
    }

    @Override
    public void deletePromptTemplatesApplicationsBackup(Long id) {
        // 校验存在
        validatePromptTemplatesApplicationsBackupExists(id);
        // 删除
        promptTemplatesApplicationsBackupMapper.deleteById(id);
    }

    private void validatePromptTemplatesApplicationsBackupExists(Long id) {
        if (promptTemplatesApplicationsBackupMapper.selectById(id) == null) {
            throw exception(PROMPT_TEMPLATES_APPLICATIONS_BACKUP_NOT_EXISTS);
        }
    }

    @Override
    public PromptTemplatesApplicationsBackupDO getPromptTemplatesApplicationsBackup(Long id) {
        return promptTemplatesApplicationsBackupMapper.selectById(id);
    }

    @Override
    public PageResult<PromptTemplatesApplicationsBackupDO> getPromptTemplatesApplicationsBackupPage(PromptTemplatesApplicationsBackupPageReqVO pageReqVO) {
        return promptTemplatesApplicationsBackupMapper.selectPage(pageReqVO);
    }

}
